import java.lang.Math;
import java.util.Arrays;

class Generation{
	
	private Eye[] generation;
	private int generation_number=0;
		
	//-------------------------------------------------------------------------------------
	// the constructor
	// constructs a new generation of 100 eyes
	//-------------------------------------------------------------------------------------
	public Generation(){
		generation=new Eye[100];//initiallizing 100 new eyes
		for(int i=0;i<100;i++)
			generation[i]=new Eye();
	}
	
	//-------------------------------------------------------------------------------------
	// this is the main method that runs the algorithm.
	// we sort the old generation by fitness.
	// we then produce 100 new offsprings:
	// in each iteration we select two parents, apply a mating function on them, 
	// and then by a small probability mutate their child
	// this child is the choise of the new generation
	//-------------------------------------------------------------------------------------
	public void run(){
		
		boolean stop=false;
		Eye final_eye=new Eye();
	
		while(stop==false){
			
			Eye[] new_generation=new Eye[100];
			Arrays.sort(generation);//after this the generation array is ordered
			Eye fittest=generation[99];
			stop=fittest.isFit();
			final_eye=fittest;
			//fittest.print();
				
			for(int i=0;i<100;i++){
				
				Eye mother=selectEye();
				
				Eye father=selectEye();
				
				Eye son=reproduce(mother,father);
				
				son.mutate();
				
				new_generation[i]=son;
					
			}//while new generation hasn't been built yet
			
			generation=new_generation;
			
			generation_number++;
		}//while work is not done
		
		//the next lines are calculations for the final output
		double radius=final_eye.getRadius();
		double lens=final_eye.getLens();
		double alfa=Math.PI-(100.0/(2*radius));
		double p=radius+radius*Math.cos(alfa);
		double a=2*radius*Math.sin(alfa);
		System.out.println("the eye is ready after "+generation_number+" generations!!!");
		System.out.println("it's apperture is "+a+", it's depth is "+p+", and it's lens is "+lens);	
	}//run
	
	//-------------------------------------------------------------------------------------
	// this method selects a parent for reproducing
	// it gives more chances to fitter parents than to weaker ones, but still 
	// everyone has a chance
	//-------------------------------------------------------------------------------------
	public Eye selectEye(){
		int selected_parent=99-(int)Math.floor(Math.pow(Math.random(),2)*100);//old
		//int selected_parent=(int)Math.floor(Math.pow(Math.random(),2)*100);
		return generation[selected_parent];
	}
	//-------------------------------------------------------------------------------------
	// this methods gets two parents and reproduced one offspring. the son has a 30%
	// chance of ending up like his mother, 30% like his father, and 40% like the
	// average of both his parents.
	//-------------------------------------------------------------------------------------
	public Eye reproduce(Eye m,Eye f){
		
		Eye son=new Eye();
		double mother_radius=m.getRadius();
		double father_radius=f.getRadius();
		double mother_lens=m.getLens();
		double father_lens=f.getLens();
		
		double son_radius=(mother_radius+father_radius)/2;
		double son_lens=(mother_lens+father_lens)/2;
		
		if (Math.random()<0.4 ){
			son.setRadius(son_radius);
			son.setLens(son_lens);
		}
		else if (Math.random()<0.7){
			son.setRadius(mother_radius);
			son.setLens(mother_lens);
		}
		else{
			son.setRadius(father_radius);
			son.setLens(father_lens);
		}
		
		return son;	
	}//reproduce	
}//generation