import java.lang.Comparable;
import java.lang.Math;

class Eye implements Comparable{
	
	private double radius=1000;
	private double lens=1000;
	private double fitness=0;
	
	public Eye(){}
	
//-----------------------------------------------------------------------------------
// The compareTo function is the function needed in order to implement Comparable
// it compares the fitness of the eye to a given different eye.
//-----------------------------------------------------------------------------------		
	public int compareTo(Object object){
		Eye eye=(Eye)object;
		if (fitness>eye.getFitness())
			return 1;
		else if(fitness<eye.getFitness())
			return -1;
		else return 0;	
	}
//-----------------------------------------------------------------------------------
// this function mutates the eye.
// it does so by a chance of 0.001%
// if the radius is not right yet, then the radius is changed.
// otherwise, the lens is changed.
// at the end we update the eye's fitness
//-----------------------------------------------------------------------------------	
	public void mutate(){
		//first of all mutate by a chance of 0.001%:
		if(Math.random()<0.001){//if you have to mutate
		
		 	double random_number=Math.random();
			
			if(random_number<0.5){
				if (radius>17.1) // if the shape is not good enough
					radius=radius*0.999;
				else{
					lens=lens*0.999;
				}
			}
			else{
				if (radius>17.1)
					radius=radius*1.001;
				else{
					lens=lens*1.001;
				}
			}
		}//if you were supposed to mutate
				
		//now update your fitness
		updateFitness();
	}
//-----------------------------------------------------------------------------------
// this function calculates the fitness of the eye according to the radius and lens
// it is invoked at the last stage of the creation of a new eye - after it is mutated
//-----------------------------------------------------------------------------------	
	public void updateFitness(){
		double alfa=Math.PI-(50.0/radius);
		double p=radius+radius*Math.cos(alfa);
		double a=2*radius*Math.sin(alfa);
		double how_close_radius=Math.abs(5.263-(p/a));
		double how_close_lens=Math.abs(p-lens);

		fitness=(1/how_close_radius)+(1/how_close_lens);
	}	
//-------------------------------------------------------------------------------------
// get methods
//-------------------------------------------------------------------------------------
	public double getRadius(){
			return radius;
	}
	public double getLens(){
		return lens;
	}
	public double getFitness(){
		return fitness;
	}
	
//-------------------------------------------------------------------------------------
// set methods
//-------------------------------------------------------------------------------------
	public void setRadius(double r){
		radius=r;
	}
	
	public void setLens(double l){
		lens=l;
	}
	
	public void setFitness(double f){
		fitness=f;
	}
	
	public void print(){
		System.out.println("r: "+radius+" p: "+lens+" fitness: "+fitness);
	}
	//public void print(){
	//	double alfa=Math.PI-(50.0/radius);
	//	double p=radius+radius*Math.cos(alfa);
	//	double a=2*radius*Math.sin(alfa);
	//	System.out.println("r: "+radius+" p: "+p+" a: "+a+" p/a "+p/a);
	//}
	
	public boolean isFit(){//a method in order to stop the evolution
		if (fitness>100)
			return true;
		else
			return false;	
	}
		
}